<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPortAndBandwidth ArrayType
 * @subpackage Arrays
 */
class ArrayOfPortAndBandwidth extends AbstractStructArrayBase
{
    /**
     * The PortAndBandwidth
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PortAndBandwidth[]
     */
    public $PortAndBandwidth;
    /**
     * Constructor method for ArrayOfPortAndBandwidth
     * @uses ArrayOfPortAndBandwidth::setPortAndBandwidth()
     * @param \StructType\PortAndBandwidth[] $portAndBandwidth
     */
    public function __construct(array $portAndBandwidth = array())
    {
        $this
            ->setPortAndBandwidth($portAndBandwidth);
    }
    /**
     * Get PortAndBandwidth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PortAndBandwidth[]|null
     */
    public function getPortAndBandwidth()
    {
        return isset($this->PortAndBandwidth) ? $this->PortAndBandwidth : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPortAndBandwidth method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPortAndBandwidth method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePortAndBandwidthForArrayConstraintsFromSetPortAndBandwidth(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPortAndBandwidthPortAndBandwidthItem) {
            // validation for constraint: itemType
            if (!$arrayOfPortAndBandwidthPortAndBandwidthItem instanceof \StructType\PortAndBandwidth) {
                $invalidValues[] = is_object($arrayOfPortAndBandwidthPortAndBandwidthItem) ? get_class($arrayOfPortAndBandwidthPortAndBandwidthItem) : sprintf('%s(%s)', gettype($arrayOfPortAndBandwidthPortAndBandwidthItem), var_export($arrayOfPortAndBandwidthPortAndBandwidthItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PortAndBandwidth property can only contain items of type \StructType\PortAndBandwidth, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PortAndBandwidth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PortAndBandwidth[] $portAndBandwidth
     * @return \ArrayType\ArrayOfPortAndBandwidth
     */
    public function setPortAndBandwidth(array $portAndBandwidth = array())
    {
        // validation for constraint: array
        if ('' !== ($portAndBandwidthArrayErrorMessage = self::validatePortAndBandwidthForArrayConstraintsFromSetPortAndBandwidth($portAndBandwidth))) {
            throw new \InvalidArgumentException($portAndBandwidthArrayErrorMessage, __LINE__);
        }
        if (is_null($portAndBandwidth) || (is_array($portAndBandwidth) && empty($portAndBandwidth))) {
            unset($this->PortAndBandwidth);
        } else {
            $this->PortAndBandwidth = $portAndBandwidth;
        }
        return $this;
    }
    /**
     * Add item to PortAndBandwidth value
     * @throws \InvalidArgumentException
     * @param \StructType\PortAndBandwidth $item
     * @return \ArrayType\ArrayOfPortAndBandwidth
     */
    public function addToPortAndBandwidth(\StructType\PortAndBandwidth $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PortAndBandwidth) {
            throw new \InvalidArgumentException(sprintf('The PortAndBandwidth property can only contain items of type \StructType\PortAndBandwidth, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PortAndBandwidth[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PortAndBandwidth|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PortAndBandwidth|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PortAndBandwidth|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PortAndBandwidth|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PortAndBandwidth|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PortAndBandwidth
     */
    public function getAttributeName()
    {
        return 'PortAndBandwidth';
    }
}
