<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ListTypes' => '\\StructType\\ListTypes',
            'ListTypesResponse' => '\\StructType\\ListTypesResponse',
            'Types' => '\\StructType\\Types',
            'ArrayOfItem' => '\\ArrayType\\ArrayOfItem',
            'Item' => '\\StructType\\Item',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'ArrayOfCloudConnectProvider' => '\\ArrayType\\ArrayOfCloudConnectProvider',
            'CloudConnectProvider' => '\\StructType\\CloudConnectProvider',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt_1',
            'GetNNIAgreements' => '\\StructType\\GetNNIAgreements',
            'GetNNIAgreementsResponse' => '\\StructType\\GetNNIAgreementsResponse',
            'ArrayOfNNIAgreement' => '\\ArrayType\\ArrayOfNNIAgreement',
            'NNIAgreement' => '\\StructType\\NNIAgreement',
            'FindQuotation' => '\\StructType\\FindQuotation',
            'FindQuotationResponse' => '\\StructType\\FindQuotationResponse',
            'Quotation' => '\\StructType\\Quotation',
            'CircuitDetails' => '\\StructType\\CircuitDetails',
            'ArrayOfPortAndBandwidth' => '\\ArrayType\\ArrayOfPortAndBandwidth',
            'PortAndBandwidth' => '\\StructType\\PortAndBandwidth',
            'ArrayOfLocationIdentifier' => '\\ArrayType\\ArrayOfLocationIdentifier',
            'LocationIdentifier' => '\\StructType\\LocationIdentifier',
            'ArrayOfCloudConnectRequest' => '\\ArrayType\\ArrayOfCloudConnectRequest',
            'CloudConnectRequest' => '\\StructType\\CloudConnectRequest',
            'ArrayOfQuotationLine' => '\\ArrayType\\ArrayOfQuotationLine',
            'QuotationLine' => '\\StructType\\QuotationLine',
            'GenerateQuotation' => '\\StructType\\GenerateQuotation',
            'GenerateQuotationResponse' => '\\StructType\\GenerateQuotationResponse',
            'GetNNICapablePoPs' => '\\StructType\\GetNNICapablePoPs',
            'GetNNICapablePoPsResponse' => '\\StructType\\GetNNICapablePoPsResponse',
            'ArrayOfNNICapablePoP' => '\\ArrayType\\ArrayOfNNICapablePoP',
            'NNICapablePoP' => '\\StructType\\NNICapablePoP',
            'Address' => '\\StructType\\Address',
            'GetEthernetPoPs' => '\\StructType\\GetEthernetPoPs',
            'GetEthernetPoPsResponse' => '\\StructType\\GetEthernetPoPsResponse',
            'ArrayOfEthernetPoP' => '\\ArrayType\\ArrayOfEthernetPoP',
            'EthernetPoP' => '\\StructType\\EthernetPoP',
            'GetLocationCapabilities' => '\\StructType\\GetLocationCapabilities',
            'GetLocationCapabilitiesResponse' => '\\StructType\\GetLocationCapabilitiesResponse',
            'ArrayOfLocation' => '\\ArrayType\\ArrayOfLocation',
            'Location' => '\\StructType\\Location',
            'GetOpticalPoPs' => '\\StructType\\GetOpticalPoPs',
            'GetOpticalPoPsResponse' => '\\StructType\\GetOpticalPoPsResponse',
            'ArrayOfOpticalPoP' => '\\ArrayType\\ArrayOfOpticalPoP',
            'OpticalPoP' => '\\StructType\\OpticalPoP',
        );
    }
}
